/*	
 *	main.c
 *
 *	P/EMU - P/ECE Emulator
 *	Copyright (C) 2003 Naoyuki Sawa
 *
 *	* Mon Apr 14 00:00:00 JST 2003 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "app.h"

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

HINSTANCE hinst;			/* CX^Xnh */
HWND hwnd;				/* CEChE */
unsigned char keystate[256];		/* L[ */
unsigned char vbuff[DISP_Y][DISP_X];	/* zVRAM */

/****************************************************************************
 *	[Jϐ
 ****************************************************************************/

static int o_dbg;		/* fobObZ[W̏o͗LH */

static struct {			/* ʓ]prbg}bv */
	BITMAPINFOHEADER bi;
	RGBQUAD rgb[256];
} bmi;

/****************************************************************************
 *	
 ****************************************************************************/

/* fobObZ[W̏o */
void
dbg(const char* fmt, ...)
{
	if(o_dbg) {
		va_list ap;
		va_start(ap, fmt);
		vfprintf(stderr, fmt, ap);
		va_end(ap);
		fprintf(stderr, "\n");
	}
	/* p */
}

/* ُI */
void
die(const char* fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	vfprintf(stderr, fmt, ap);
	va_end(ap);
	fprintf(stderr, "\n");
	abort();
}

/****************************************************************************
 *	
 ****************************************************************************/

static LRESULT CALLBACK
WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
	PAINTSTRUCT ps;
	int x, y;

	switch(msg) {
	case WM_DESTROY:
		exit(0);
		return 0;
	case WM_PAINT:
		hDC = BeginPaint(hWnd, &ps);
		SetDIBitsToDevice(hDC, 0, 0, DISP_X, DISP_Y, 0, 0, 0, DISP_Y, vbuff, (BITMAPINFO*)&bmi, DIB_RGB_COLORS);
		EndPaint(hWnd, &ps);
		return 0;
	case WM_KEYDOWN:
		keystate[wParam & 255] = 1;
		return 0;
	case WM_KEYUP:
		keystate[wParam & 255] = 0;
		return 0;
	case WM_ACTIVATE:
		if(LOWORD(wParam)/*=fActive*/) {
			joySetCapture(hWnd, JOYSTICKID1, 1000 / 60/*=polling freq*/, TRUE); /* G[ */
		} else {
			joyReleaseCapture(JOYSTICKID1); /* G[ */
			memset(keystate, 0, sizeof keystate);
		}
		return 0;
	case MM_JOY1MOVE:
	case MM_JOY1BUTTONUP:
	case MM_JOY1BUTTONDOWN:
		x = LOWORD(lParam);
		y = HIWORD(lParam);
		keystate[KEY_LEFT  ] = x < 0x4000;
		keystate[KEY_RIGHT ] = x > 0xc000;
		keystate[KEY_UP    ] = y < 0x4000;
		keystate[KEY_DOWN  ] = y > 0xc000;
		keystate[KEY_A     ] = (wParam & JOY_BUTTON1) != 0;
		keystate[KEY_B     ] = (wParam & JOY_BUTTON2) != 0;
		keystate[KEY_START ] = (wParam & JOY_BUTTON3) != 0;
		keystate[KEY_SELECT] = (wParam & JOY_BUTTON4) != 0;
		return 0;
	}
	return DefWindowProc(hWnd, msg, wParam, lParam);
}

static void
ui_init()
{
	int i;
	BITMAPINFOHEADER* bi;
	RGBQUAD* rgb;
	WNDCLASS wc;
	RECT rc;

	/* CX^Xnh擾B */
	hinst = GetModuleHandle(NULL);

	/* ʓ]prbg}bv쐬B */
	memset(&bmi, 0, sizeof bmi);
	bi = &bmi.bi;
	rgb = bmi.rgb;
	bi->biSize = sizeof(BITMAPINFOHEADER);
	bi->biWidth = DISP_X;
	bi->biHeight = -DISP_Y; /* gbv_E */
	bi->biPlanes = 1;
	bi->biBitCount = 8;
	i = 0;
	do {
		rgb[i].rgbRed   =
		rgb[i].rgbGreen =
		rgb[i].rgbBlue  = 255 * (3 - i) / 3;
		i++;
	} while(i < 4);
	do {
		rgb[i].rgbRed   = 255;
		rgb[i].rgbGreen =   0;
		rgb[i].rgbBlue  = 255;
		i++;
	} while(i < 256);

	/* EChE쐬B */
	memset(&wc, 0, sizeof wc);
	wc.lpfnWndProc = WndProc;
	wc.hInstance = hinst;
	wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.lpszClassName = APPNAME;
	RegisterClass(&wc);
	SetRect(&rc, 0, 0, DISP_X, DISP_Y);
	AdjustWindowRect(&rc, WS_POPUP | WS_CAPTION | WS_BORDER | WS_SYSMENU, 0);
	hwnd = CreateWindow(APPNAME, APPNAME, WS_POPUP | WS_CAPTION | WS_BORDER | WS_SYSMENU,
			0, 0, rc.right - rc.left, rc.bottom - rc.top,
			NULL, NULL, hinst, NULL);
	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);
}

int
main(int argc, char* argv[])
{
	int i;
	char* p;
	MSG msg;

	printf("=================================\n");
	printf("P/EMU - P/ECE Emulator (%s)\n", VERSION);
	printf("Copyright (C) 2003 Naoyuki Sawa\n");
	printf("=================================\n");

	/* R}hCB */
	for(i = 1; i < argc; i++) {
		p = argv[i];
		if(*p == '-') {
			p++;
			switch(*p) {
			case 'd':
				o_dbg = 1;
				break;
			default:
				DIE();
			}
		} else {
			DIE();
		}
	}

	/* UIB */
	ui_init();

	/* G~[^B */
	emu_init();

	printf("@@@\n");
	printf("@@@@@@@@L[{[h@WCpbh\n");
	printf("㉺E@@F@@@@@\n");
	printf("`{^@@F@y@@@@@P@@@@@\n");
	printf("a{^@@F@w@@@@@Q@@@@@\n");
	printf("rs`qs@F@`@@@@@R@@@@@\n");
	printf("rdkdbsF@r@@@@@S@@@@@\n");

	/* C[vB */
	for(;;) {
		while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		emu_work();
	}

	return 0;
}
